Index: test/bfs_test.cc
===================================================================
--- test/bfs_test.cc	(revision 2247)
+++ test/bfs_test.cc	(revision 2260)
@@ -21,5 +21,5 @@
 #include <lemon/bfs.h>
 #include <lemon/path.h>
-#include<lemon/concept/graph.h>
+#include<lemon/concepts/graph.h>
 
 using namespace lemon;
@@ -30,5 +30,5 @@
 void check_Bfs_Compile() 
 {
-  typedef concept::Graph Graph;
+  typedef concepts::Graph Graph;
 
   typedef Graph::Edge Edge;
@@ -67,5 +67,5 @@
 {
   typedef int VType;
-  typedef concept::Graph Graph;
+  typedef concepts::Graph Graph;
 
   typedef Graph::Edge Edge;
@@ -73,5 +73,5 @@
   typedef Graph::EdgeIt EdgeIt;
   typedef Graph::NodeIt NodeIt;
-  typedef concept::ReadMap<Edge,VType> LengthMap;
+  typedef concepts::ReadMap<Edge,VType> LengthMap;
    
   Graph g;
@@ -79,8 +79,8 @@
   bfs(g).source(Node()).run();
   bfs(g)
-    .predMap(concept::WriteMap<Node,Edge>())
-    .distMap(concept::WriteMap<Node,VType>())
-    .reachedMap(concept::ReadWriteMap<Node,bool>())
-    .processedMap(concept::WriteMap<Node,bool>())
+    .predMap(concepts::WriteMap<Node,Edge>())
+    .distMap(concepts::WriteMap<Node,VType>())
+    .reachedMap(concepts::ReadWriteMap<Node,bool>())
+    .processedMap(concepts::WriteMap<Node,bool>())
     .run(Node());
   
Index: test/bpugraph_test.cc
===================================================================
--- test/bpugraph_test.cc	(revision 2231)
+++ test/bpugraph_test.cc	(revision 2260)
@@ -17,5 +17,5 @@
  */
 
-#include <lemon/concept/bpugraph.h>
+#include <lemon/concepts/bpugraph.h>
 #include <lemon/list_graph.h>
 #include <lemon/smart_graph.h>
@@ -29,5 +29,5 @@
 
 using namespace lemon;
-using namespace lemon::concept;
+using namespace lemon::concepts;
 
 void check_concepts() {
Index: test/dfs_test.cc
===================================================================
--- test/dfs_test.cc	(revision 2247)
+++ test/dfs_test.cc	(revision 2260)
@@ -21,5 +21,5 @@
 #include <lemon/dfs.h>
 #include <lemon/path.h>
-#include <lemon/concept/graph.h>
+#include <lemon/concepts/graph.h>
 
 using namespace lemon;
@@ -30,5 +30,5 @@
 void check_Dfs_SmartGraph_Compile() 
 {
-  typedef concept::Graph Graph;
+  typedef concepts::Graph Graph;
 
   typedef Graph::Edge Edge;
@@ -68,5 +68,5 @@
 {
   typedef int VType;
-  typedef concept::Graph Graph;
+  typedef concepts::Graph Graph;
 
   typedef Graph::Edge Edge;
@@ -74,5 +74,5 @@
   typedef Graph::EdgeIt EdgeIt;
   typedef Graph::NodeIt NodeIt;
-  typedef concept::ReadMap<Edge,VType> LengthMap;
+  typedef concepts::ReadMap<Edge,VType> LengthMap;
    
   Graph g;
@@ -80,8 +80,8 @@
   dfs(g).source(Node()).run();
   dfs(g)
-    .predMap(concept::WriteMap<Node,Edge>())
-    .distMap(concept::WriteMap<Node,VType>())
-    .reachedMap(concept::ReadWriteMap<Node,bool>())
-    .processedMap(concept::WriteMap<Node,bool>())
+    .predMap(concepts::WriteMap<Node,Edge>())
+    .distMap(concepts::WriteMap<Node,VType>())
+    .reachedMap(concepts::ReadWriteMap<Node,bool>())
+    .processedMap(concepts::WriteMap<Node,bool>())
     .run(Node());
   
Index: test/dijkstra_test.cc
===================================================================
--- test/dijkstra_test.cc	(revision 2247)
+++ test/dijkstra_test.cc	(revision 2260)
@@ -22,6 +22,6 @@
 #include <lemon/path.h>
 #include <lemon/maps.h>
-#include <lemon/concept/graph.h>
-#include <lemon/concept/maps.h>
+#include <lemon/concepts/graph.h>
+#include <lemon/concepts/maps.h>
 using namespace lemon;
 
@@ -32,5 +32,5 @@
 {
   typedef int VType;
-  typedef concept::Graph Graph;
+  typedef concepts::Graph Graph;
 
   typedef Graph::Edge Edge;
@@ -38,5 +38,5 @@
   typedef Graph::EdgeIt EdgeIt;
   typedef Graph::NodeIt NodeIt;
-  typedef concept::ReadMap<Edge,VType> LengthMap;
+  typedef concepts::ReadMap<Edge,VType> LengthMap;
  
   typedef Dijkstra<Graph, LengthMap> DType;
@@ -71,5 +71,5 @@
 {
   typedef int VType;
-  typedef concept::Graph Graph;
+  typedef concepts::Graph Graph;
 
   typedef Graph::Edge Edge;
@@ -77,5 +77,5 @@
   typedef Graph::EdgeIt EdgeIt;
   typedef Graph::NodeIt NodeIt;
-  typedef concept::ReadMap<Edge,VType> LengthMap;
+  typedef concepts::ReadMap<Edge,VType> LengthMap;
    
   Graph g;
@@ -83,6 +83,6 @@
   dijkstra(g,LengthMap()).source(Node()).run();
   dijkstra(g,LengthMap())
-    .predMap(concept::WriteMap<Node,Edge>())
-    .distMap(concept::WriteMap<Node,VType>())
+    .predMap(concepts::WriteMap<Node,Edge>())
+    .distMap(concepts::WriteMap<Node,VType>())
     .run(Node());
   
Index: test/edge_set_test.cc
===================================================================
--- test/edge_set_test.cc	(revision 2111)
+++ test/edge_set_test.cc	(revision 2260)
@@ -4,6 +4,6 @@
 #include <vector>
 
-#include <lemon/concept/graph.h>
-#include <lemon/concept/ugraph.h>
+#include <lemon/concepts/graph.h>
+#include <lemon/concepts/ugraph.h>
 #include <lemon/smart_graph.h>
 
@@ -16,5 +16,5 @@
 
 using namespace lemon;
-using namespace lemon::concept;
+using namespace lemon::concepts;
 
 typedef SmartGraph RGraph;
Index: test/graph_adaptor_test.cc
===================================================================
--- test/graph_adaptor_test.cc	(revision 2231)
+++ test/graph_adaptor_test.cc	(revision 2260)
@@ -21,7 +21,7 @@
 
 #include<lemon/smart_graph.h>
-#include<lemon/concept/graph.h>
-#include<lemon/concept/ugraph.h>
-#include<lemon/concept/bpugraph.h>
+#include<lemon/concepts/graph.h>
+#include<lemon/concepts/ugraph.h>
+#include<lemon/concepts/bpugraph.h>
 
 #include<lemon/list_graph.h>
@@ -42,5 +42,5 @@
 
 using namespace lemon;
-using namespace lemon::concept;
+using namespace lemon::concepts;
 
 
Index: test/graph_factory_test.cc
===================================================================
--- test/graph_factory_test.cc	(revision 2111)
+++ test/graph_factory_test.cc	(revision 2260)
@@ -19,6 +19,6 @@
 #include<iostream>
 #include<lemon/smart_graph.h>
-#include<lemon/concept/graph.h>
-#include<lemon/concept/maps.h>
+#include<lemon/concepts/graph.h>
+#include<lemon/concepts/maps.h>
 #include<lemon/list_graph_base.h>
 #include<lemon/full_graph.h>
@@ -71,20 +71,20 @@
 
 //Compile Graph
-template void lemon::concept::checkCompileGraph<concept::Graph>
-(concept::Graph &);
+template void lemon::concepts::checkCompileGraph<concepts::Graph>
+(concepts::Graph &);
 
 template
-void lemon::concept::checkCompileGraph<concept::Graph>
-(concept::Graph &);
+void lemon::concepts::checkCompileGraph<concepts::Graph>
+(concepts::Graph &);
 
 template
-void lemon::concept::checkCompileGraph<concept::Graph>
-(concept::Graph &);
+void lemon::concepts::checkCompileGraph<concepts::Graph>
+(concepts::Graph &);
 
 //Compile SmartGraph
 template
-void lemon::concept::checkCompileGraph<SmartGraph>(SmartGraph &);
+void lemon::concepts::checkCompileGraph<SmartGraph>(SmartGraph &);
 template
-void lemon::concept::checkCompileGraphFindEdge<SmartGraph>(SmartGraph &);
+void lemon::concepts::checkCompileGraphFindEdge<SmartGraph>(SmartGraph &);
 
 //Compile SymSmartGraph
@@ -94,9 +94,9 @@
 //Compile ListGraph
 template
-void lemon::concept::checkCompileGraph<ListGraph>(ListGraph &);
+void lemon::concepts::checkCompileGraph<ListGraph>(ListGraph &);
 template
-void lemon::concept::checkCompileGraph<ListGraph>(ListGraph &);
+void lemon::concepts::checkCompileGraph<ListGraph>(ListGraph &);
 template
-void lemon::concept::checkCompileGraphFindEdge<ListGraph>(ListGraph &);
+void lemon::concepts::checkCompileGraphFindEdge<ListGraph>(ListGraph &);
 
 
@@ -107,7 +107,7 @@
 
 //Compile FullGraph
-template void lemon::concept::checkCompileGraph<FullGraph>(FullGraph &);
+template void lemon::concepts::checkCompileGraph<FullGraph>(FullGraph &);
 template
-void lemon::concept::checkCompileGraphFindEdge<FullGraph>(FullGraph &);
+void lemon::concepts::checkCompileGraphFindEdge<FullGraph>(FullGraph &);
 
 
@@ -144,5 +144,5 @@
   // Some map tests.
   // FIXME: These shouldn't be here.
-  using namespace concept;
+  using namespace concepts;
   function_requires< ReadMapConcept< ReadMap<int,int> > >();
   function_requires< WriteMapConcept< WriteMap<int,int> > >();
Index: test/graph_test.cc
===================================================================
--- test/graph_test.cc	(revision 2231)
+++ test/graph_test.cc	(revision 2260)
@@ -20,5 +20,5 @@
 #include <vector>
 
-#include <lemon/concept/graph.h>
+#include <lemon/concepts/graph.h>
 #include <lemon/list_graph.h>
 #include <lemon/smart_graph.h>
@@ -32,5 +32,5 @@
 
 using namespace lemon;
-using namespace lemon::concept;
+using namespace lemon::concepts;
 
 
Index: test/heap_test.cc
===================================================================
--- test/heap_test.cc	(revision 2108)
+++ test/heap_test.cc	(revision 2260)
@@ -23,5 +23,5 @@
 
 #include <lemon/concept_check.h>
-#include <lemon/concept/heap.h>
+#include <lemon/concepts/heap.h>
 
 #include <lemon/smart_graph.h>
@@ -41,5 +41,5 @@
 
 using namespace lemon;
-using namespace lemon::concept;
+using namespace lemon::concepts;
 
 
Index: test/kruskal_test.cc
===================================================================
--- test/kruskal_test.cc	(revision 2135)
+++ test/kruskal_test.cc	(revision 2260)
@@ -24,6 +24,6 @@
 #include <lemon/kruskal.h>
 #include <lemon/list_graph.h>
-#include <lemon/concept/maps.h>
-#include <lemon/concept/graph.h>
+#include <lemon/concepts/maps.h>
+#include <lemon/concepts/graph.h>
 
 
@@ -33,9 +33,9 @@
 void checkCompileKruskal()
 {
-  concept::WriteMap<concept::Graph::Edge,bool> w;
+  concepts::WriteMap<concepts::Graph::Edge,bool> w;
 
-  concept::Graph g;
+  concepts::Graph g;
   kruskal(g,
-	  concept::ReadMap<concept::Graph::Edge,int>(),
+	  concepts::ReadMap<concepts::Graph::Edge,int>(),
 	  w);
 }
Index: test/maps_test.cc
===================================================================
--- test/maps_test.cc	(revision 2032)
+++ test/maps_test.cc	(revision 2260)
@@ -21,5 +21,5 @@
 
 #include <lemon/concept_check.h>
-#include <lemon/concept/maps.h>
+#include <lemon/concepts/maps.h>
 #include <lemon/maps.h>
 
@@ -27,5 +27,5 @@
 
 using namespace lemon;
-using namespace lemon::concept;
+using namespace lemon::concepts;
 
 struct A {};
Index: test/matrix_maps_test.cc
===================================================================
--- test/matrix_maps_test.cc	(revision 2242)
+++ test/matrix_maps_test.cc	(revision 2260)
@@ -22,7 +22,7 @@
 #include <lemon/concept_check.h>
 
-#include <lemon/concept/matrix_maps.h>
-#include <lemon/concept/maps.h>
-#include <lemon/concept/graph.h>
+#include <lemon/concepts/matrix_maps.h>
+#include <lemon/concepts/maps.h>
+#include <lemon/concepts/graph.h>
 
 #include <lemon/matrix_maps.h>
@@ -36,5 +36,5 @@
 
 using namespace lemon;
-using namespace lemon::concept;
+using namespace lemon::concepts;
 
 int main() {
Index: test/path_test.cc
===================================================================
--- test/path_test.cc	(revision 2247)
+++ test/path_test.cc	(revision 2260)
@@ -20,6 +20,6 @@
 #include <iostream>
 
-#include <lemon/concept/path.h>
-#include <lemon/concept/graph.h>
+#include <lemon/concepts/path.h>
+#include <lemon/concepts/graph.h>
 
 #include <lemon/path.h>
@@ -32,9 +32,9 @@
 
 void check_concepts() {
-  checkConcept<concept::Path<concept::Graph>, 
-    concept::Path<concept::Graph> >();
-  checkConcept<concept::Path<concept::Graph>, 
-    Path<concept::Graph> >();
-  checkConcept<concept::Path<ListGraph>, Path<ListGraph> >();
+  checkConcept<concepts::Path<concepts::Graph>, 
+    concepts::Path<concepts::Graph> >();
+  checkConcept<concepts::Path<concepts::Graph>, 
+    Path<concepts::Graph> >();
+  checkConcept<concepts::Path<ListGraph>, Path<ListGraph> >();
 }
 
Index: test/preflow_test.cc
===================================================================
--- test/preflow_test.cc	(revision 2111)
+++ test/preflow_test.cc	(revision 2260)
@@ -24,6 +24,6 @@
 #include <lemon/dimacs.h>
 #include <lemon/preflow.h>
-#include <lemon/concept/graph.h>
-#include <lemon/concept/maps.h>
+#include <lemon/concepts/graph.h>
+#include <lemon/concepts/maps.h>
 
 using namespace lemon;
@@ -32,11 +32,11 @@
 {
   typedef int VType;
-  typedef concept::Graph Graph;
+  typedef concepts::Graph Graph;
 
   typedef Graph::Node Node;
   typedef Graph::Edge Edge;
-  typedef concept::ReadMap<Edge,VType> CapMap;
-  typedef concept::ReadWriteMap<Edge,VType> FlowMap;
-  typedef concept::ReadWriteMap<Node,bool> CutMap;
+  typedef concepts::ReadMap<Edge,VType> CapMap;
+  typedef concepts::ReadWriteMap<Edge,VType> FlowMap;
+  typedef concepts::ReadWriteMap<Node,bool> CutMap;
  
   typedef Preflow<Graph, int, CapMap, FlowMap> PType;
Index: test/test_tools.h
===================================================================
--- test/test_tools.h	(revision 2242)
+++ test/test_tools.h	(revision 2260)
@@ -27,5 +27,5 @@
 
 #include <lemon/concept_check.h>
-#include <lemon/concept/graph.h>
+#include <lemon/concepts/graph.h>
 
 #include <lemon/random.h>
Index: test/ugraph_test.cc
===================================================================
--- test/ugraph_test.cc	(revision 2231)
+++ test/ugraph_test.cc	(revision 2260)
@@ -18,5 +18,5 @@
 
 #include <lemon/bits/graph_extender.h>
-#include <lemon/concept/ugraph.h>
+#include <lemon/concepts/ugraph.h>
 #include <lemon/list_graph.h>
 #include <lemon/smart_graph.h>
@@ -30,5 +30,5 @@
 
 using namespace lemon;
-using namespace lemon::concept;
+using namespace lemon::concepts;
 
 void check_concepts() {